"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PQueue = void 0;
const PQueueDequeueOptimized_1 = require("./PQueueDequeueOptimized");
const PQueueEnqueuOptimized_1 = require("./PQueueEnqueuOptimized");
class PQueue {
    constructor(options) {
        if ((options === null || options === void 0 ? void 0 : options.optimization) === 'dequeue') {
            this._internalQueue = new PQueueDequeueOptimized_1.PQueueDequeueOptimized();
        }
        else {
            this._internalQueue = new PQueueEnqueuOptimized_1.PQueueEnqueuOptimized();
        }
    }
    enQueue(value, priority) {
        this._internalQueue.enQueue(value, priority);
    }
    deQueue() {
        return this._internalQueue.deQueue();
    }
}
exports.PQueue = PQueue;
