"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PQueueDequeueOptimized = void 0;
class PQueueDequeueOptimized {
    constructor() {
        this.dummy = {
            val: "dummy",
            priority: Number.MAX_SAFE_INTEGER
        };
    }
    enQueue(value, priority) {
        const item = {
            val: value,
            priority
        };
        if (!this.dummy.next) {
            this.dummy.next = item;
            return;
        }
        let temp = this.dummy;
        while (temp && temp.next) {
            if (item.priority > temp.next.priority) {
                item.next = temp.next;
                temp.next = item;
                return;
            }
            temp = temp.next;
        }
        temp.next = item;
    }
    deQueue() {
        if (!this.dummy.next) {
            throw new Error("The list is empty");
        }
        const max = this.dummy.next.val;
        this.dummy.next = this.dummy.next.next;
        return max;
    }
}
exports.PQueueDequeueOptimized = PQueueDequeueOptimized;
